<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"><a href="javascript:void(0);">SmartAdmin</a></li>
            <li class="breadcrumb-item"><router-link to="/index">Dashboard</router-link></li>
            <li class="breadcrumb-item active">Surveys</li>
        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-chart-bar'></i> Survey<span class='fw-300'></span>
            </h1>
            <div class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center mr-3">
                    <button class="btn btn-success" @click="addNewSurvey()">
                        <i class="fas fa-user-plus"></i> Add Survey
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>
        <div class="row text-center">
            <div class="row">
                <div class="col-xl-12 col-md-12">
                    <div id="panel-1" class="panel">
                        <div class="panel-hdr">
                            <h2>
                                Survey <span class="fw-300"><i>List</i></span>
                            </h2>
                            <div class="panel-toolbar">
                                <button class="btn btn-panel" data-action="panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></button>
                                <button class="btn btn-panel" data-action="panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></button>
                            </div>
                        </div>
                        <div class="panel-container show">
                            <div class="panel-content">
                                <!-- datatable start -->
                                <table id="dt-basic-example" class="table table-bordered table-hover table-striped w-100">
                                    <thead>
                                        <tr>
                                            <th>S.N.</th>
                                            <th style="width:250px">Title</th>
                                            <th style="width:250px">Author</th>
                                            <th style="width:250px">Status</th>
                                            <th style="width:250px">Actions</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr v-for="(survey, index) in surveys" :key="survey._id">
                                            <td>{{ index+=1 }}</td>
                                            <td>{{ survey.survey.title }}</td>
                                            <td>{{ survey.user }}</td>
                                            <td>{{ survey.status }}</td>
                                            <td>
                                                <button class="btn btn-sm btn-success" @click="viewSurvey(survey._id)" style="margin: 5px;">
                                                    <i class="fas fa-play"></i> Run
                                                </button>
                                            </td>

                                        </tr>
                                    </tbody>
                                </table>
                                <!-- datatable end -->
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
    import axios from "axios";

    export default {
        name: 'Surveys',
        data() {
            return{
                surveys: []
            }
        },

        async created() {
            let fetchSurveys = await axios.get('http://ec2-54-89-84-11.compute-1.amazonaws.com:3000/api/surveys',
                {
                    headers: {
                        'Authorization': `Bearer ${localStorage.getItem('accessToken')}`
                    }
                });

            const currentUser = localStorage.getItem('username');
            const currentUserRole = localStorage.getItem('role');

            if(currentUserRole == 'admin') {
                this.surveys = fetchSurveys.data.data;
            } else {
                this.surveys = fetchSurveys.data.data.filter(data => { return data.status == 'approved' || data.user == currentUser })
            }

        },

        methods: {
            viewSurvey(id){
                this.$router.push(`/surveyDetail/${id}`)
            },

            addNewSurvey() {
                this.$router.push('/surveyCreator');
            }
        }
    }
</script>

<style scoped>

</style>
